Commit 94831b13 authored by Florian Westphal's avatar Florian Westphal Committed by Jakub Kicinski

selftests: netfilter: bridge_brouter.sh: move to lib.sh infra

Doing so gets us dynamically generated netns names.

Also:
* do not assume rp_filter is disabled, if its on script failed
* reduce timeout (-W) for "expected to fail" ping commands
* don't print PASS line for basic sanity ping
* shellcheck cleanups
Signed-off-by: default avatarFlorian Westphal <fw@strlen.de>
Link: https://lore.kernel.org/r/20240411233624.8129-3-fw@strlen.deSigned-off-by: default avatarJakub Kicinski <kuba@kernel.org>
parent 3f189349
...@@ -5,142 +5,118 @@ ...@@ -5,142 +5,118 @@
# part of a bridge. # part of a bridge.
# eth0 br0 eth0 # eth0 br0 eth0
# setup is: ns1 <-> ns0 <-> ns2 # setup is: ns1 <-> nsbr <-> ns2
# Kselftest framework requirement - SKIP code is 4. source lib.sh
ksft_skip=4
ret=0
ebtables -V > /dev/null 2>&1 if ! ebtables -V > /dev/null 2>&1;then
if [ $? -ne 0 ];then
echo "SKIP: Could not run test without ebtables" echo "SKIP: Could not run test without ebtables"
exit $ksft_skip exit $ksft_skip
fi fi
ip -Version > /dev/null 2>&1 cleanup() {
if [ $? -ne 0 ];then cleanup_all_ns
echo "SKIP: Could not run test without ip tool" }
exit $ksft_skip
fi
ip netns add ns0 trap cleanup EXIT
ip netns add ns1
ip netns add ns2
ip link add veth0 netns ns0 type veth peer name eth0 netns ns1 setup_ns nsbr ns1 ns2
if [ $? -ne 0 ]; then
ip netns exec "$nsbr" sysctl -q net.ipv4.conf.default.rp_filter=0
ip netns exec "$nsbr" sysctl -q net.ipv4.conf.all.rp_filter=0
if ! ip link add veth0 netns "$nsbr" type veth peer name eth0 netns "$ns1"; then
echo "SKIP: Can't create veth device" echo "SKIP: Can't create veth device"
exit $ksft_skip exit $ksft_skip
fi fi
ip link add veth1 netns ns0 type veth peer name eth0 netns ns2 ip link add veth1 netns "$nsbr" type veth peer name eth0 netns "$ns2"
ip -net ns0 link set lo up
ip -net ns0 link set veth0 up
ip -net ns0 link set veth1 up
ip -net ns0 link add br0 type bridge if ! ip -net "$nsbr" link add br0 type bridge; then
if [ $? -ne 0 ]; then
echo "SKIP: Can't create bridge br0" echo "SKIP: Can't create bridge br0"
exit $ksft_skip exit $ksft_skip
fi fi
ip -net ns0 link set veth0 master br0 ip -net "$nsbr" link set veth0 up
ip -net ns0 link set veth1 master br0 ip -net "$nsbr" link set veth1 up
ip -net ns0 link set br0 up
ip -net ns0 addr add 10.0.0.1/24 dev br0 ip -net "$nsbr" link set veth0 master br0
ip -net "$nsbr" link set veth1 master br0
ip -net "$nsbr" link set br0 up
ip -net "$nsbr" addr add 10.0.0.1/24 dev br0
# place both in same subnet, ns1 and ns2 connected via ns0:br0 # place both in same subnet, ${ns1} and ${ns2} connected via ${nsbr}:br0
for i in 1 2; do ip -net "$ns1" link set eth0 up
ip -net ns$i link set lo up ip -net "$ns2" link set eth0 up
ip -net ns$i link set eth0 up ip -net "$ns1" addr add 10.0.0.11/24 dev eth0
ip -net ns$i addr add 10.0.0.1$i/24 dev eth0 ip -net "$ns2" addr add 10.0.0.12/24 dev eth0
done
test_ebtables_broute() test_ebtables_broute()
{ {
local cipt
# redirect is needed so the dstmac is rewritten to the bridge itself, # redirect is needed so the dstmac is rewritten to the bridge itself,
# ip stack won't process OTHERHOST (foreign unicast mac) packets. # ip stack won't process OTHERHOST (foreign unicast mac) packets.
ip netns exec ns0 ebtables -t broute -A BROUTING -p ipv4 --ip-protocol icmp -j redirect --redirect-target=DROP if ! ip netns exec "$nsbr" ebtables -t broute -A BROUTING -p ipv4 --ip-protocol icmp -j redirect --redirect-target=DROP; then
if [ $? -ne 0 ]; then
echo "SKIP: Could not add ebtables broute redirect rule" echo "SKIP: Could not add ebtables broute redirect rule"
return $ksft_skip return $ksft_skip
fi fi
# ping netns1, expected to not work (ip forwarding is off) ip netns exec "$nsbr" sysctl -q net.ipv4.conf.veth0.forwarding=0
ip netns exec ns1 ping -q -c 1 10.0.0.12 > /dev/null 2>&1
if [ $? -eq 0 ]; then # ping net${ns1}, expected to not work (ip forwarding is off)
if ip netns exec "$ns1" ping -q -c 1 10.0.0.12 -W 0.5 > /dev/null 2>&1; then
echo "ERROR: ping works, should have failed" 1>&2 echo "ERROR: ping works, should have failed" 1>&2
return 1 return 1
fi fi
# enable forwarding on both interfaces. # enable forwarding on both interfaces.
# neither needs an ip address, but at least the bridge needs # neither needs an ip address, but at least the bridge needs
# an ip address in same network segment as ns1 and ns2 (ns0 # an ip address in same network segment as ${ns1} and ${ns2} (${nsbr}
# needs to be able to determine route for to-be-forwarded packet). # needs to be able to determine route for to-be-forwarded packet).
ip netns exec ns0 sysctl -q net.ipv4.conf.veth0.forwarding=1 ip netns exec "$nsbr" sysctl -q net.ipv4.conf.veth0.forwarding=1
ip netns exec ns0 sysctl -q net.ipv4.conf.veth1.forwarding=1 ip netns exec "$nsbr" sysctl -q net.ipv4.conf.veth1.forwarding=1
sleep 1
ip netns exec ns1 ping -q -c 1 10.0.0.12 > /dev/null if ! ip netns exec "$ns1" ping -q -c 1 10.0.0.12 > /dev/null; then
if [ $? -ne 0 ]; then
echo "ERROR: ping did not work, but it should (broute+forward)" 1>&2 echo "ERROR: ping did not work, but it should (broute+forward)" 1>&2
return 1 return 1
fi fi
echo "PASS: ns1/ns2 connectivity with active broute rule" echo "PASS: ${ns1}/${ns2} connectivity with active broute rule"
ip netns exec ns0 ebtables -t broute -F ip netns exec "$nsbr" ebtables -t broute -F
# ping netns1, expected to work (frames are bridged) # ping net${ns1}, expected to work (frames are bridged)
ip netns exec ns1 ping -q -c 1 10.0.0.12 > /dev/null if ! ip netns exec "$ns1" ping -q -c 1 10.0.0.12 > /dev/null; then
if [ $? -ne 0 ]; then
echo "ERROR: ping did not work, but it should (bridged)" 1>&2 echo "ERROR: ping did not work, but it should (bridged)" 1>&2
return 1 return 1
fi fi
ip netns exec ns0 ebtables -t filter -A FORWARD -p ipv4 --ip-protocol icmp -j DROP ip netns exec "$nsbr" ebtables -t filter -A FORWARD -p ipv4 --ip-protocol icmp -j DROP
# ping netns1, expected to not work (DROP in bridge forward) # ping net${ns1}, expected to not work (DROP in bridge forward)
ip netns exec ns1 ping -q -c 1 10.0.0.12 > /dev/null 2>&1 if ip netns exec "$ns1" ping -q -c 1 10.0.0.12 -W 0.5 > /dev/null 2>&1; then
if [ $? -eq 0 ]; then
echo "ERROR: ping works, should have failed (icmp forward drop)" 1>&2 echo "ERROR: ping works, should have failed (icmp forward drop)" 1>&2
return 1 return 1
fi fi
# re-activate brouter # re-activate brouter
ip netns exec ns0 ebtables -t broute -A BROUTING -p ipv4 --ip-protocol icmp -j redirect --redirect-target=DROP ip netns exec "$nsbr" ebtables -t broute -A BROUTING -p ipv4 --ip-protocol icmp -j redirect --redirect-target=DROP
ip netns exec ns2 ping -q -c 1 10.0.0.11 > /dev/null if ! ip netns exec "$ns2" ping -q -c 1 10.0.0.11 > /dev/null; then
if [ $? -ne 0 ]; then
echo "ERROR: ping did not work, but it should (broute+forward 2)" 1>&2 echo "ERROR: ping did not work, but it should (broute+forward 2)" 1>&2
return 1 return 1
fi fi
echo "PASS: ns1/ns2 connectivity with active broute rule and bridge forward drop" echo "PASS: ${ns1}/${ns2} connectivity with active broute rule and bridge forward drop"
return 0 return 0
} }
# test basic connectivity # test basic connectivity
ip netns exec ns1 ping -c 1 -q 10.0.0.12 > /dev/null if ! ip netns exec "$ns1" ping -c 1 -q 10.0.0.12 > /dev/null; then
if [ $? -ne 0 ]; then echo "ERROR: Could not reach ${ns2} from ${ns1}" 1>&2
echo "ERROR: Could not reach ns2 from ns1" 1>&2 exit 1
ret=1
fi fi
ip netns exec ns2 ping -c 1 -q 10.0.0.11 > /dev/null if ! ip netns exec "$ns2" ping -c 1 -q 10.0.0.11 > /dev/null; then
if [ $? -ne 0 ]; then echo "ERROR: Could not reach ${ns1} from ${ns2}" 1>&2
echo "ERROR: Could not reach ns1 from ns2" 1>&2 exit 1
ret=1
fi
if [ $ret -eq 0 ];then
echo "PASS: netns connectivity: ns1 and ns2 can reach each other"
fi fi
test_ebtables_broute test_ebtables_broute
ret=$? exit $?
for i in 0 1 2; do ip netns del ns$i;done
exit $ret
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment